    Imports System
    Imports NXOpen
    Imports NXOpen.UF
    Imports NXOpen.BlockStyler
     
     
    Module Module2
     
     
     
        Dim theSession As Session = Session.GetSession()
        Dim theLW As NXOpen.ListingWindow = theSession.ListingWindow()
        Dim theUI As NXOpen.UI = NXOpen.UI.GetUI()
        Dim theNXMessageBox As NXMessageBox = theUI.NXMessageBox
     
     
        Sub Main()
            Dim theSession As Session = Session.GetSession()
            Dim theLW As NXOpen.ListingWindow
            theLW = theSession.ListingWindow()
     
            theLW.Open()
            Doit()
     
        End Sub
     
        Sub Doit()
     
            Dim nom_loadcase As String
            Dim resultParameters1 As CAE.ResultParameters
            Dim theSession As Session = Session.GetSession()
            Dim resultManager1 As CAE.ResultManager = theSession.ResultManager
            Dim simPart As CAE.SimPart = CType(theSession.Parts.BaseWork, CAE.SimPart)
            Dim simulation As CAE.SimSimulation = simPart.Simulation()
            Dim workSimPart As CAE.SimPart = CType(theSession.Parts.BaseWork, CAE.SimPart)
            Dim solution As CAE.SimSolution = simulation.ActiveSolution()
            Dim results As CAE.Result = GetResults(solution) 
            Dim resultType As CAE.Result.Type       
            Dim scale As Double = 1.0
     
            Dim solutionResult1 = resultManager1.CreateSolutionResult(simulation.ActiveSolution())
     
            Dim loadcase1 As NXOpen.CAE.Loadcase = CType(solutionResult1.Find("Loadcase[1]"), NXOpen.CAE.Loadcase)
            Dim iteration1 As NXOpen.CAE.Iteration = CType(loadcase1.Find("Iteration[1]"), NXOpen.CAE.Iteration)
            Dim resultType1 As NXOpen.CAE.ResultType = CType(iteration1.Find("ResultType[[Stress][Element-Nodal]]"), NXOpen.CAE.ResultType)
     
            Dim loadCaseIdx As Integer = loadcase1.Label
            Dim iterationIdx As Integer = iteration1.Label
            Dim resultAccess As CAE.ResultAccess = GetResultAccess(results, resultType1, loadCaseIdx, iterationIdx, scale)
            Dim noeud_result As Double = resultAccess.AskMaximum
            Dim Msg, Stl, Ttle
            Msg = noeud_result
            Stl = vbOKOnly
            Ttle = "Maximum Result"
            MsgBox(Msg, Stl, Ttle)
            SendToExcel(noeud_result)
     
        End Sub
     
        Function GetResultAccess(ByRef results As CAE.Result, ByRef resultType As CAE.ResultType, ByVal loadCaseIdx As Integer, ByVal iterationIdx As Integer, ByVal scale As Double) As CAE.ResultAccess
     
            Dim part As BasePart = theSession.Parts.BaseWork
            Dim theResultManager As CAE.ResultManager = theSession.ResultManager()
            Dim unit_stress As Unit = CType(part.UnitCollection.FindObject("MilliNewtonPerSquareMilliMeter"), Unit)
            Dim resultParameter As CAE.ResultParameters = theResultManager.CreateResultParameters()
     
            'resultType.Quantity = CAE.Result.Quantity.Displacement'Stress'
            'resultType.Location = CAE.Result.Location.Nodal'ElementNodal'
            'resultType.Section = CAE.Result.Section.NotApplicable
          
     
     
            Dim averaging As CAE.Result.Averaging
     
            averaging.DoAveraging = False
            averaging.AverageAcrossPropertyIds = True
            averaging.AverageAcrossMaterialIds = True
            averaging.AverageAcrossElementTypes = False
            averaging.AverageAcrossFeatangle = True
            averaging.AverageAcrossAnglevalue = 45.0
            averaging.IncludeInternalElementContributions = True
     
            resultParameter.SetLoadcaseIteration(loadCaseIdx, iterationIdx)
            resultParameter.SetGenericResultType(resultType)
            resultParameter.SetResultComponent(CAE.Result.Component.VonMises)
            resultParameter.SetSectionPlyLayer(0, 0, 0)
            resultParameter.SetAveragingCriteria(averaging)
            resultParameter.SetCoordinateSystem(CAE.Result.CoordinateSystem.AbsoluteRectangular)
            resultParameter.SetElementValueCriterion(CAE.Result.ElementValueCriterion.Average)
            resultParameter.SetComplexCriterion(CAE.Result.Complex.Amplitude)
            resultParameter.SetPhaseAngle(0.0)
            resultParameter.SetScale(scale)
            'resultParameter.SetUnit = unit_stress
            Dim solResultsAccess As CAE.ResultAccess = theResultManager.CreateResultAccess(results, resultParameter)
            solResultsAccess.SetParameters(resultParameter)
     
            Return solResultsAccess
     
        End Function
     
        Function GetResults(ByRef solution As CAE.SimSolution) As CAE.Result
     
            Dim results As CAE.Result = Nothing
            Dim part As BasePart = theSession.Parts.BaseWork
            Dim theResultManager As CAE.ResultManager = theSession.ResultManager()
            Dim solresults As CAE.SolutionResult = theResultManager.CreateSolutionResult(solution)
     
            results = CType(solresults, CAE.Result)
     
            Return results
     
        End Function
     
        Function SendToExcel(value As Double)
            Dim theExcelFile As String = "C:\Users\AlexBolyn\Documents\NX\journaling_spreadsheet\Spreadsheet_DT_tuto.xlsx"
    	
    		Dim objExcel = CreateObject("Excel.Application")
    			
    		Dim objWorkbook = objExcel.Workbooks.open(theExcelFile)
    		objExcel.Visible = True
    		
    			
    		objExcel.Cells(8, 2).value = value/1000
    		 
    		objExcel.ScreenUpdating = True
         End Function
     
     
    End Module




